@/home/kbah/code/RGB/code/sub_pro/COMPUTE_LUT.pro
@/home/kbah/code/RGB/code/sub_pro/MAKE_DAILY_LUT.pro
@/home/kbah/code/RGB/code/sub_pro/READ_VAR.pro


PRO MAKE_RGB

;;;;;; in paths  ;;;;;;;

inpath01='/cimss/REALTIME_PROXY/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'
inpath02='/cimss/SCHAACK/REALTIME_PROXY_ALL_BADGER_EAST/CRTMOUT/625X421/Netcdf/Without_Time/Realtime/'
outpath='/data/kbah/output/rgb/'


;;;VARS    ;;;;;;
ayear='2014'
drange=[0,1.25]
gspace=[0.20]
;;;;;;;;;;;;;;;;;;;;;;;;

 FOR a=5, 12 DO BEGIN    ;;;MONTHS
    amonth=STRTRIM(STRING(a),1)
    IF (a LE 9) THEN amonth= '0'+ STRTRIM(STRING(a),1)  
    FOR b=1, 31 DO BEGIN    ;;;;DAYS
      aday=STRTRIM(STRING(b),1)
      IF (b LE 9) THEN aday='0'+STRTRIM(STRING(b),1)
      adate=ayear+'_'+amonth+'_'+aday+'_00'
      inpath=inpath02 + adate
      G_LUT=MAKE_DAILY_LUT(inpath=inpath, outpath=outpath, drange=drange, gspace=gspace,adate=adate)   
    ENDFOR
 ENDFOR

END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;SUB ROUTINES   ;;;;;;;;;;;;;;;;;;;;;;;
FUNCTION MAKE_DAILY_LUT, inpath=inpath,  outpath=outpath, drange=drange, gspace=gspace,adate=adate
      ;infiles=FILE_SEARCH(inpath,'*crtmvis*.nc')
      green_band=FILE_SEARCH(inpath, '*crtmvis_modis_band4*.nc')
      other_bands=FILE_SEARCH(inpath, '*crtmvis_no_ray*.nc')
      countg=SIZE(green_band, /N_ELEMENTS)
      counto=SIZE(other_bands, /N_ELEMENTS)
      
      gvar='MODIS_refl_b04' &  b01var='ABI_refl_b01'  
      b02var='ABI_refl_b02' &  b03var='ABI_refl_b03' 
      
      ;;;;;;;;;CREATE CUBES   ;;;;;;;;;
      maxrange=ROUND((drange[1]*100) *(1/gspace))
      gcube=FLTARR(maxrange, maxrange, maxrange) 
      accube={ccube:LONARR(maxrange, maxrange, maxrange), acube:FLTARR(maxrange, maxrange, maxrange)}
      
      IF (countg NE counto) THEN BEGIN
            PRINT, 'Number of green bands does not match the number of vis bands'
      ENDIF ELSE BEGIN
       For c=12, countg -1 DO BEGIN   ;number of hrs eg:24
           print,'hr=', c
           gfile=green_band(c)   &   ofile=other_bands(c)
                  
           g_data=READ_VAR(gfile, gvar)      &      r_data=READ_VAR(ofile, b01var)
           b_data=READ_VAR(ofile, b02var)    &      n_data=READ_VAR(ofile, b03var)  
           
          ; PRINT, 'gdata MIN, MAX=', min(g_data.data), max(g_data.data) 
           PRINT, 'Non zero ccube =', SIZE(WHERE(accube.ccube GT 0), /N_ELEMENTS)
           PRINT, 'Non zero acube =', SIZE(WHERE(accube.acube GT 0), /N_ELEMENTS)
        
           cubes=COMPUTE_LUT(r_data, b_data, g_data, n_data, accube)
                
           ;print, 'stop'
       ENDFOR
       
       gcube(*,*,*)= cubes.acube(*,*,*)/cubes.ccube(*,*,*)
      
       outfile= outpath + adate +'_green_lux.txt'
      
      openw, lun2, outfile, /get_lun
      printf, lun2, SIZE(gcube, /N_ELEMENTS)
      printf, lun2, gcube
      close, lun2
      free_lun, lun2
      
      kk=where (gcube gt 0)
      print, 'Filled cubes: ',size(kk,/ n_elements), '       out of: ', size(gcube, /n_elements)
      print,'file made:', outfile
      ENDELSE
      
      
RETURN,0
END


FUNCTION COMPUTE_LUT, r_data, b_data, g_data, n_data, accube
     ss=size(r_data.data, /N_ELEMENTS)
     FOR d=0, ss-1 DO BEGIN   ;data points/pixels for one time period
            red=ROUND(r_data.data(d)*100)  &  blue=ROUND(B_data.data(d)*100)   &  nir= ROUND(N_data.data(d)*100)
              ; PRINT, RED, BLUE, NIR
            green=(G_data.data(d)) 
            IF (red LE 125 AND blue LE 125 AND nir LE 125) THEN BEGIN          
                accube.ccube(red,blue,nir)= accube.ccube(red,blue,nir)+1   ;;;COUNTER
                accube.acube(red,blue,nir)= accube.acube(red,blue,nir)+green ;; ACCUMULATION
                ; print, red, green, blue, nir
            ENDIF
     ENDFOR
     
RETURN, accube
END



FUNCTION READ_VAR, afile, avar
      ncdfid= NCDF_OPEN(afile(0))
      
      fileinfo= NCDF_INQUIRE(ncdfid)
      dname1='west_east' & dname2='south_north' ; & dname3=avar       
      
      WE = NCDF_DIMID( ncdfid, dname1) 
      SE = NCDF_DIMID( ncdfid, dname2)
     ; data=NCDF_DIMID( ncdfid, dname3)
    
      NCDF_DIMINQ, ncdfid, WE, Name1, Size1 
      NCDF_DIMINQ, ncdfid, SE, Name2, Size2
    
      ;var_lats={data:FLTARR(Size1,Size2),units:'', name:''}  
      ;var_lons={data:FLTARR(Size1,Size2),units:'', name:''} 
      var_data={data:FLTARR(Size1,Size2),units:'', name:''}
   
      ngatts=fileinfo.ngatts
      nvars=fileinfo.nvars
      varnames=STRARR(nvars)
      
      FOR j=0L, nvars -1L DO BEGIN
           varinfo=NCDF_VARINQ(ncdfid,j)
           varnames(j)=varinfo.name  
     ENDFOR
    
     j=WHERE(varnames(*) EQ avar(0))  
     IF (SIZE(j, /N_ELEMENTS) GE 1) THEN BEGIN
             varinfo=NCDF_VARINQ(ncdfid,j(0))
            ;dataset(i).var=varinfo.name            
             varid=NCDF_VARID(ncdfid, varinfo.name)
             NCDF_VARGET,ncdfid, varid, temp_data
             var_data.data = temp_data
              
             pp=NCDF_attname(ncdfid, varid, 0)
             NCDF_ATTGET, ncdfid, varid, pp, attvalue
             var_data.units=string(attvalue); Attribute value
            
             pp=NCDF_attname(ncdfid, varid, 1)
             NCDF_ATTGET, ncdfid, varid, pp, attvalue
             var_data.name=string(attvalue); Attribute value
    ENDIF
 RETURN,var_data
END
