@/home/kbah/code/RGB/code/sub_pro/READ_VAR.pro
@/home/kbah/code/RGB/code/sub_pro/COMPUTE_LUT.pro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;SUB ROUTINES   ;;;;;;;;;;;;;;;;;;;;;;;
FUNCTION MAKE_DAILY_LUT, inpath=inpath,  outpath=outpath, drange=drange, gspace=gspace,adate=adate
      ;infiles=FILE_SEARCH(inpath,'*crtmvis*.nc')
      green_band=FILE_SEARCH(inpath, '*crtmvis_modis_band4*.nc')
      other_bands=FILE_SEARCH(inpath, '*crtmvis_no_ray*.nc')
      countg=SIZE(green_band, /N_ELEMENTS)
      counto=SIZE(other_bands, /N_ELEMENTS)
      
      gvar='MODIS_refl_b04' &  b01var='ABI_refl_b01'  
      b02var='ABI_refl_b02' &  b03var='ABI_refl_b03' 
      
      ;;;;;;;;;CREATE CUBES   ;;;;;;;;;
      maxrange=ROUND((drange[1]*100) *(1/gspace[0]))
      xvar=gspace(0)*findgen(maxrange)/100.
      yvar=gspace(0)*findgen(maxrange)/100.
      zvar=gspace(0)*findgen(maxrange)/100.
      gcube=FLTARR(maxrange, maxrange, maxrange) 
      accube={ccube:LONARR(maxrange, maxrange, maxrange), acube:FLTARR(maxrange, maxrange, maxrange)}
      
      IF (countg NE counto) THEN BEGIN
            PRINT, 'Number of green bands does not match the number of vis bands'
      ENDIF ELSE BEGIN
;       For c=12, countg -1 DO BEGIN   ;number of hrs eg:24
       For c=0,11 DO BEGIN      ; rbp bug fix
           print,'hr=', c
           gfile=green_band(c)   &   ofile=other_bands(c)
           print,gfile,' ',ofile       
           g_data=READ_VAR(gfile, gvar)      &      r_data=READ_VAR(ofile, b01var)
           b_data=READ_VAR(ofile, b02var)    &      n_data=READ_VAR(ofile, b03var)  
           
          ; PRINT, 'gdata MIN, MAX=', min(g_data.data), max(g_data.data) 
           PRINT, 'Non zero ccube =', SIZE(WHERE(accube.ccube GT 0), /N_ELEMENTS)
           PRINT, 'Non zero acube =', SIZE(WHERE(accube.acube GT 0), /N_ELEMENTS)
;       help,r_data,b_data,g_data,n_data,accube 
           cubes=COMPUTE_LUT(r_data, b_data, g_data, n_data, accube, maxrange, gspace[0])
                
           ;print, 'stop'
       ENDFOR
       index=where(cubes.ccube ne 0)
       gcube(index)=cubes.acube(index)/cubes.ccube(index)
;       gcube(*,*,*)= cubes.acube(*,*,*)/cubes.ccube(*,*,*)

       outfile= outpath + adate +'_green_lux.dat'
;help,xvar,yvar,zvar
      openw, lun2, outfile,/f77, /get_lun
      writeu,lun2,SIZE(gcube, /DIMENSIONS)
      writeu,lun2,xvar,yvar,zvar
      writeu,lun2,gcube
      close,lun2
      free_lun,lun2
      
       
      kk=where (gcube gt 0)
      print, 'Filled cubes: ',size(kk,/ n_elements), '       out of: ', size(gcube, /n_elements)
      print,'file made:', outfile
      ENDELSE
      
      
RETURN,0
END
