@/home/kbah/code/idl/rgb/sub_pro/READ_VAR.pro
@/home/kbah/code/idl/rgb/sub_pro/WRITE_RGB_NETCDF_BASIC.pro
@/home/kbah/code/idl/rgb/sub_pro/WRITE_PROCESSED_RGB_NETCDF .pro
;@/home/kbah/code/idl/rgb/sub_pro/WRITE_RGB_NETCDF.pro
;@/home/kbah/code/idl/rgb/sub_pro/ScaleModis.pro

PRO MAKE_RGB_IMAGES

       ;;;;;; in paths  ;;;;;;;
       sub_dir= 'hourly/' ;'daily/'

       inpathrbn0='/data3/input/frappe/crtmout/' ;/data1/input/rgb/toarads/'
       inpathcmask0='/data3/input/frappe/wrfout/'
       inpath_cube='/data1/input/rgb/green-cubes/'+sub_dir
       drange=[0,1.25]  &  gspace=[0.20]  &  inpath=inpathrbn0  & search_range=[10] ;;index eg +-10
       ncoutpath='/data2/output/rgb/hourly/netcdf/'
       fil_path='/home/kbah/code/idl/rgb/sh_files/fil_files/'
       ; hourly_data_to_process19.fil'
       
       filfiles=FILE_SEARCH(fil_path, '2014_07_20_*.fil')   ;0022000*.fil')
       
         ;; Blue, red, green, nir
       minrefl=[-0.04087, -0.03969, -0.0390,-0.03900]
       maxrefl=[1.26699,1.23043,1.2100, 1.2088]

      FOR  a=0, N_ELEMENTS(filfiles)-1 DO BEGIN 
          adate='' & anhr=''
          afilfile=filfiles[a]
          print, 'afilfile:', afilfile
          close, 1 
          openr,1,afilfile 
          readf,1, adate  &    readf,1, anhr
          close, 1        &    print, 'date= ', adate, ' ', anhr
          inpathrbn=inpathrbn0 ;+adate+'/'
          inpathcmask=inpathcmask0+ adate+'/'
          
          ;;;;;;;;;;;;;;;;;;;;;;;;
          datafiles=file_search(inpathrbn, '*.nc')
          cmaskfiles=file_search(inpathcmask, '*.nc')
          
          IF (N_ELEMENTS(datafiles) GT 1) THEN BEGIN
                
                rbn=READ_RBN(inpathrbn=inpathrbn, adate=adate, anhr=anhr)
                cmask=READ_CMASK(inpathcmask=inpathcmask, adate=adate, anhr=anhr)
                ;lutgreen=RETRIEVE_GREEN(inpath_cube=inpath_cube, rbn=rbn, drange=drange, gspace=gspace, adate=adate, anhr=anhr, search_range=search_range, minrefl=minrefl, maxrefl=maxrefl)
                lutgreen=rbn.green.data

                print, 'red min, max:', min(rbn.red.data),  max(rbn.red.data)
                print, 'blue min, max:', min(rbn.blue.data),  max(rbn.blue.data)
                print, 'sgreen min, max:', min(rbn.green.data) , max(rbn.green.data)
                print, 'nir min, max:', min(rbn.nir.data),  max(rbn.nir.data)
                print, 'lutgreen min, max:', min(lutgreen),  max(lutgreen)


                ;WRITE_RGB_NETCDF_BASIC, rbn=rbn, lutgreen=lutgreen, cmask=cmask, ncoutpath=ncoutpath, adate=adate, anhr=anhr, minrefl=minrefl, maxrefl=maxrefl
                WRITE_PROCESSED_RGB_NETCDF, rbn=rbn, lutgreen=lutgreen, cmask=cmask, ncoutpath=ncoutpath, adate=adate, anhr=anhr, minrefl=minrefl, maxrefl=maxrefl

                 ;red=round(rbn.red.data*255)  & blue=round(rbn.blue.data*255)  & lutgreen=round(lutgreen*255)
          ENDIF ELSE BEGIN
             PRINT, 'No files found in:',inpathrbn
             PRINT, ' '
          ENDELSE  
           print, 'stop'      
      ENDFOR
      
END




























;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;; Sub routines  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;cmask=READ_CMASK(inpathcmask=inpathcmask, adate=adate, anhr=anhr)
FUNCTION READ_CMASK, inpathcmask=inpathcmask, adate=adate, anhr=anhr

  cmaskfile=FILE_SEARCH(inpathcmask, 'wrfout_d01*'+STRING(strmid(adate,8,3))+STRING(strmid(anhr,0,2))+'*:00')
  
  landmask=READ_VAR(cmaskfile, 'XLAND')  &   vegfrac=READ_VAR(cmaskfile, 'VEGFRA')  &  coszen=READ_VAR(cmaskfile, 'COSZEN')       &   lai=READ_VAR(cmaskfile, 'LAI') 
  tsk=READ_VAR(cmaskfile, 'TSK')         &   albedo=READ_VAR(cmaskfile, 'ALBEDO')   &  emiss=READ_VAR(cmaskfile,'EMISS')        ;&   e_co=READ_VAR(cmaskfile, 'E_CO')           &   e_no=READ_VAR(cmaskfile,'E_NO') 
  ;  ebu_oc=READ_VAR(cmaskfile,'ebu_oc')    &  pm2_5_dry=READ_VAR(cmaskfile,'PM2_5_DRY')  &   pm10=READ_VAR(cmaskfile,'PM10')

  print, 'Finished reading file: ', cmaskfile

  wrfoutdata={landmask:landmask, vegfrac:vegfrac, coszen:coszen, lai:lai, tsk:tsk, albedo:albedo, emiss:emiss}  ;, e_co:e_co ,e_no:e_no, ebu_oc:ebu_oc, pm2_5_dry:pm2_5_dry, pm10:pm10}

  RETURN, wrfoutdata 

END




FUNCTION READ_RBN, inpathrbn=inpathrbn, adate=adate, anhr=anhr
      tday=FIX(strmid(anhr, 0,2))
      IF (tday LE 11) THEN BEGIN
          ayear=STRING(STRMID(adate, 0,4)) & amonth=STRING(STRMID(adate,5,2)) & aday=STRING(STRMID(adate,8,2))-1
          adate=ayear+'_'+amonth+'_'+STRTRIM(STRING(aday),1)+'_00'
          PRINT, 'STOP'
      ENDIF
      
    inpathrbn=inpathrbn +adate+'/'
    rbnfile=FILE_SEARCH(inpathrbn, '*crtmvis_no_ray*'+anhr+'*.nc')
    gfile=FILE_SEARCH(inpathrbn, '*crtmvis_modis_band4*'+anhr+'*.nc')
    szfile='/data1/input/rgb/toarads/2014_05_01_00/TOArads_abi_conus_east_crtmir_2014.05.01.230000_CRTM_V2.1_realtime.cimss.emissivity.nc'
   
    latvar='lat'  & lonvar='lon'  & solarzen='zenang' &  b01var='ABI_refl_b01' &   b02var='ABI_refl_b02' &  b03var='ABI_refl_b03' & gvar='MODIS_refl_b04'

    lat_data=READ_VAR(rbnfile, latvar)  &    lon_data=READ_VAR(rbnfile, lonvar)  &  solarzen_data=READ_VAR(rbnfile, solarzen)  & b_data=READ_VAR(rbnfile, b01var)   ; &  solarzen_data=READ_VAR(szfile, solarzen)
    r_data=READ_VAR(rbnfile, b02var)   &    n_data=READ_VAR(rbnfile, b03var)   &  g_data=READ_VAR(gfile,gvar)
    
    print, 'Finished reading file: ', rbnfile
    print,'Finished reading file: ', gfile
    
    rbn={lat: lat_data, lon:lon_data, solarzen:solarzen_data, red:r_data, blue:b_data, nir:n_data, green:g_data}

  RETURN, rbn

END




FUNCTION RETRIEVE_GREEN,inpath_cube=inpath_cube, rbn=rbn, drange=drange, gspace=gspace, adate=adate, anhr=anhr,search_range=search_range, minrefl=minrefl, maxrefl=maxrefl
       
        ayear=STRING(STRMID(adate, 0,4)) & amonth=STRING(STRMID(adate,5,2)) & aday=STRING(STRMID(adate,8,2))
        cdate=ayear +'.' +amonth +'.'+string(strmid(anhr, 0,2))+'00Z_green_lux.dat'
        
         green_cube=FILE_SEARCH(inpath_cube, cdate)  
         
         IF (N_ELEMENTS(green_cube) NE 1) THEN BEGIN
             print,'Expecting only one file with name: ', green_cube
         ENDIF  ELSE BEGIN         
            openr,1,green_cube,/f77
            dim=lonarr(3)
            readu,1,dim
            nx=dim(0)           &  ny=dim(1)         &    nz=dim(2)
            xvar=fltarr(nx)     &  yvar=fltarr(ny)   &    zvar=fltarr(nz)
            readu,1,xvar,yvar,zvar
            cube=fltarr(nx,ny,nz)
            readu,1,cube
            
            bsize=SIZE(rbn.red.data, /DIMENSIONS)
            green_lut=FLTARR(bsize[0], bsize[1])
            
            ;maxrange=ROUND((drange[1]*100) *(1/gspace[0]))    ;minrange=ROUND((drange[0]*100) *(1/gspace[0]))
            outbound=0l
            missing=0l
            expand_found=0l
            expand_missing=0l
            
            FOR xx=0, bsize[0]-1L DO BEGIN
                FOR yy=0, bsize[1]-1L DO BEGIN
                      ;IF (rbn.blue.data(xx,yy) EQ maxval ) THEN BEGIN
                      ;  PRINT, 'STOP'
                        rindex=ROUND((rbn.red.data(xx,yy)*100.)*1/gspace[0])
                        bindex=ROUND((rbn.blue.data(xx,yy)*100.)*1/gspace[0])
                        nindex=ROUND((rbn.nir.data(xx,yy)*100.)*1/gspace[0])
                        
                        ra= ROUND((minrefl[0]*100.)*1/gspace[0])  & rb= ROUND((maxrefl[0]*100.)*1/gspace[0])
                        ba= ROUND((minrefl[1]*100.)*1/gspace[0])  & bb= ROUND((maxrefl[1]*100.)*1/gspace[0])
                        na= ROUND((minrefl[3]*100.)*1/gspace[0])  & nb= ROUND((maxrefl[3]*100.)*1/gspace[0])
                        
                        IF (rindex GE ra and rindex LE rb AND bindex GE ba AND bindex LE bb AND nindex GE na AND nindex LE nb) THEN BEGIN  ;;CHECK TO MAKE SURE YOU ARE WITHIN drange
                                IF (cube(rindex,bindex,nindex) NE 0.0) THEN BEGIN   ;CHECK IF CUBE HAS VALUE @ THIS INDEX ELSE EXPAND SEARCH
                                       green_lut(xx,yy)=cube(rindex,bindex,nindex)
                                ENDIF ELSE BEGIN
                                     missing=missing+1
                                     green_lut(xx,yy)=rbn.green.data(xx,yy)
                                     ;es=EXPAND_SEARCH(cube, rindex,bindex, nindex,expand_found,expand_missing, search_range)
                                     ;PRINT, 'Missing=',xx,' ',yy,' ',missing
                                     ;PRINT, 'cube=',cube(rindex,bindex,nindex)
                                     ;PRINT, 'R,B,N indexes=', rindex, ' ',bindex,' ',nindex
                                ENDELSE
                               
                        ENDIF ELSE BEGIN
                              green_lut(xx,yy)=minrefl[2]  ;-999.0
                              outbound=outbound+1
                              PRINT, 'Out of range=',rindex,' ',bindex,' ',nindex,' ',outbound
                        ENDELSE 
                       ;  print, 'cube('+strtrim(string(rindex),1)+','+strtrim(string(bindex),1)+ ','+strtrim(string(nindex),1)+')=',cube(rindex,bindex,nindex)
                      ;ENDIF                       
                ENDFOR
            ENDFOR                     
         ENDELSE 
            
 
  RETURN, green_lut
END


FUNCTION EXPAND_SEARCH, cube, rindex,bindex,nindex,expand_found,expand_missing, search_range

  gpixel=0.0  & apixel=0.0
  a=rindex -search_range[0]
  b=bindex -search_range[0]
  c=nindex -search_range[0]

  WHILE (a LT rindex+search_range) DO BEGIN
    WHILE (b LT bindex+search_range) DO BEGIN
      WHILE (c LT nindex+search_range) DO BEGIN
        apixel=cube(a,b,c)
        IF (apixel NE 0.0) THEN BEGIN
          expand_found=expand_found+1
          gpixel=apixel
          BREAK
        ENDIF
        c++
      ENDWHILE
      IF (apixel NE 0.0) THEN BREAK
      b++
    ENDWHILE
    IF (apixel NE 0.0) THEN BREAK
    a++
  ENDWHILE

  IF (apixel eq 0.0) THEN expand_missing=expand_missing +1

  asearch={gpixel:gpixel, a:a,b:b,c:c,expand_found:expand_found, expand_missing:expand_missing}

  RETURN,asearch

END
