@/home/kbah/code/idl/rgb/sub_pro/READ_VAR.pro
@/home/kbah/code/idl/rgb/sub_pro/COMPUTE_LUT.pro
@/home/kbah/code/idl/rgb/sub_pro/free_all.pro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;SUB ROUTINES   ;;;;;;;;;;;;;;;;;;;;;;;


FUNCTION MAKE_HOURLY_LUT, inpath=inpath,  outpath=outpath, drange=drange, gspace=gspace,adate=adate, anhr=anhr
      ;infiles=FILE_SEARCH(inpath,'*crtmvis*.nc')
     ; print, 'start anhr=', anhr
      anhr=strtrim(string(anhr+STRTRIM('0000',1)),1)
    
      print, 'anhr=', anhr
 
      green_band=FILE_SEARCH(inpath, '*crtmvis_modis_band4'+adate+'*'+anhr+'*.nc')
      other_bands=FILE_SEARCH(inpath, '*crtmvis_no_ray*'+adate+'*'+anhr+'*.nc')
      
       ;print,'green_band=', green_band
      
     
      countg=SIZE(green_band, /N_ELEMENTS)
      counto=SIZE(other_bands, /N_ELEMENTS)
      
      gvar='MODIS_refl_b04' &  b01var='ABI_refl_b01'  
      b02var='ABI_refl_b02' &  b03var='ABI_refl_b03' 
      
      ;print, 'green bands=', green_band
      ;;;;;;;;;CREATE CUBES   ;;;;;;;;;
      maxrange=ROUND((drange[1]*100) *(1/gspace[0]))
      minrange=ROUND((drange[0]*100) *(1/gspace[0]))
      xvar=gspace(0)*findgen(maxrange)/100.
      yvar=gspace(0)*findgen(maxrange)/100.
      zvar=gspace(0)*findgen(maxrange)/100.

      gcube=FLTARR(maxrange, maxrange, maxrange) 
      accube={ccube:LONARR(maxrange, maxrange, maxrange), acube:FLTARR(maxrange, maxrange, maxrange)}
      
      IF (countg NE counto) THEN BEGIN
            PRINT, 'Number of green bands does not match the number of vis bands'
      ENDIF ELSE BEGIN
       For c=25, countg -1 DO BEGIN   ;number of hrs eg:24
 ;     ;For c=0,11 DO BEGIN      ; rbp bug fix
            ; IF (c EQ 17) THEN BEGIN
            ;        print, 'r_data.data=', r_data.data(d)
            ;        PRINT, 'r,g,n,index, green=', RED, BLUE, NIR, green
            ; ENDIF

           print,'Date=', adate+strtrim(String(c+1),1)
          ;  aday=STRTRIM(STRING(c),1)
          ; IF (aday LE 9) THEN aday= '0'+ STRTRIM(STRING(c),1)  
       
           gfile=green_band(c)   &   ofile=other_bands(c)
                  
           g_data=READ_VAR(gfile, gvar)      &      r_data=READ_VAR(ofile, b01var)
           b_data=READ_VAR(ofile, b02var)    &      n_data=READ_VAR(ofile, b03var)    
           
          ; PRINT, 'gdata MIN, MAX=', min(g_data.data), max(g_data.data) 
           PRINT, 'Non zeros in ccube =', SIZE(WHERE(accube.ccube GT 0), /N_ELEMENTS)
           PRINT, 'Non zeros in acube =', SIZE(WHERE(accube.acube GT 0), /N_ELEMENTS)
        
           cubes=COMPUTE_LUT(r_data, b_data, g_data, n_data, accube, maxrange, minrange, gspace[0])
                
           ;print, 'stop'
       ENDFOR
       index=where(cubes.ccube ne 0)
       gcube(index)=cubes.acube(index)/cubes.ccube(index)
;      gcube(*,*,*)= cubes.acube(*,*,*)/cubes.ccube(*,*,*)
       
       hdate=STRMID(adate,0,8)
       outfile= outpath + hdate+'.'+anhr +'00Z_green_lux.dat'
       print, 'outfile=',outfile
      
      openw, lun2, outfile,/f77, /get_lun
      writeu,lun2,SIZE(gcube, /DIMENSIONS)
      writeu,lun2,xvar,yvar,zvar
      writeu,lun2,gcube
      close,lun2
      free_lun,lun2
;      openw, lun2, outfile, /get_lun
;      printf, lun2, SIZE(gcube, /N_ELEMENTS)
;      printf, lun2, gcube
;      close, lun2
;      free_lun, lun2
      
      kk=where (gcube gt 0)
      print, 'Filled cubes: ',size(kk,/ n_elements), '       out of: ', size(gcube, /n_elements)
      print,'file made:', outfile
      
      free_all
      ENDELSE
      
      
RETURN,0
END
