@/home/kbah/code/RGB/code/sub_pro/ScaleModis.pro

PRO  WRITE_AHI_PROCESSED_RGB_NETCDF, rbn=rbn, lutgreen=lutgreen, cmask=cmask, ncoutpath=ncoutpath, adate=adate, anhr=anhr, minrefl=minrefl, maxrefl=maxrefl

  ;;  rbn={lat: lat_data, lon:lon_data, red:r_data, blue:b_data, nir:n_data, b13:band_13,green:g_data}
  ;        latvar='lat'  & lonvar='lon'  &  b01var='ABI_refl_b01' &   b02var='ABI_refl_b02' &  b03var='ABI_refl_b03' &  b13var='ABI_refl_b13' & gvar='MODIS_refl_b04'
  ;; lutgreen=lutgreen 2D array retrieved from cube
  
    dims=size(rbn.lat, /dimensions)
    xsize=LONG(dims(0)) & ysize=LONG(dims(1))
  
  ; rbn={lat:lat, lon:lon, red:red, blue:blue, green:green, landmask:landmask}
   
    dname=['lat', 'lon','blue', 'green', 'red', 'lutgreen', 'landmask', 'cloudmask', 'nir'] 
    lname=['Latitude', 'Longitude', 'ABI_refl_b01(0.47um)', 'ABI_refl_b02(0.55um)', 'ABI_refl_b3(0.64um)', 'LUTABI_refl_b1.5(0.55um)','landmask', 'cloudmaskn','ABI_refl_b4(0.86um)'] 
    units=['degrees_north', 'degrees_east', 'None',  'None', 'None', 'None', 'None','None', 'None']
  
    ncoutfile=ncoutpath + 'basic_AHI_RGB_bands_reflatance_'+adate+'_'+anhr+'.nc'
  
    cdfid=ncdf_create(ncoutfile, /clobber)
    ydimid =ncdf_dimdef(cdfid, 'south_north', ysize) 
    xdimid =ncdf_dimdef(cdfid, 'west_east', xsize)  
    
    
    ;;;;; lat 
    varid0= ncdf_vardef(cdfid, dname[0], [xdimid, ydimid], /float)
    ncdf_attput, cdfid, varid0, 'long_name' , lname[0]
    ncdf_attput, cdfid, varid0, 'units' , units[0]
    ncdf_attput, cdfid, varid0, '_FillValue', -999.0     
    ncdf_attput, cdfid, varid0, 'valid_range', [-90.0, 90.0]
    
    ;;;;; lon
    varid1= ncdf_vardef(cdfid, dname[1], [xdimid, ydimid], /float)
    ncdf_attput, cdfid, varid1, 'long_name' , lname[1]
    ncdf_attput, cdfid, varid1, 'units' , units[1]
    ncdf_attput, cdfid, varid1, '_FillValue', -999.0     
    ncdf_attput, cdfid, varid1, 'valid_range', [-180.0, 180.0]
    
    ;;;;;REFL. blue
    varid2= ncdf_vardef(cdfid, dname[2], [xdimid, ydimid], /float)  
    ncdf_attput, cdfid, varid2, 'long_name' , lname[2]
    ncdf_attput, cdfid, varid2, 'units' , units[2]
    ncdf_attput, cdfid, varid2, '_FillValue', -999.0     
    ncdf_attput, cdfid, varid2, 'missing_value', -999.0
    ncdf_attput, cdfid, varid2, 'coordinates' ,'Longitude Latitude' 
  
    ;;;;;REFL. green
    varid3= ncdf_vardef(cdfid, dname[3], [xdimid, ydimid], /float) 
    ncdf_attput, cdfid, varid3, 'long_name' , lname[3]
    ncdf_attput, cdfid, varid3, 'units' , units[3]
    ncdf_attput, cdfid, varid3, '_FillValue', -999.0
    ncdf_attput, cdfid, varid3, 'missing_value', -999.0
    ncdf_attput, cdfid, varid3, 'coordinates' ,'Longitude Latitude'
    
    ;;;;;REFL.red
    varid4= ncdf_vardef(cdfid, dname[4], [xdimid, ydimid], /float)  
    ncdf_attput, cdfid, varid4, 'long_name' , lname[4]
    ncdf_attput, cdfid, varid4, 'units' , units[4]
    ncdf_attput, cdfid, varid4, '_FillValue', -999.0
    ncdf_attput, cdfid, varid4, 'missing_value', -999.0
    ncdf_attput, cdfid, varid4, 'coordinates' , 'Longitude Latitude '
    
    ;;;;;REFL. lut green
    varid5= ncdf_vardef(cdfid, dname[5], [xdimid, ydimid], /float)
    ncdf_attput, cdfid, varid5, 'long_name' , lname[5]
    ncdf_attput, cdfid, varid5, 'units' , units[5]
    ncdf_attput, cdfid, varid5, '_FillValue', -999.0
    ncdf_attput, cdfid, varid5, 'missing_value', -999.0
    ncdf_attput, cdfid, varid5, 'coordinates' , 'Longitude Latitude'
    
    ;;;;;REFL. landmask
    varid6= ncdf_vardef(cdfid, dname[6], [xdimid, ydimid], /float)
    ncdf_attput, cdfid, varid6, 'long_name' , lname[6]
    ncdf_attput, cdfid, varid6, 'units' , units[6]
    ncdf_attput, cdfid, varid6, '_FillValue', -999.0
    ncdf_attput, cdfid, varid6, 'missing_value', -999.0
    ncdf_attput, cdfid, varid6, 'coordinates' , 'Longitude Latitude'

   ; ;;;;;REFL.cloudmask
    varid7= ncdf_vardef(cdfid, dname[7], [xdimid, ydimid], /float)
    ncdf_attput, cdfid, varid7, 'long_name' , lname[7]
    ncdf_attput, cdfid, varid7, 'units' , units[7]
    ncdf_attput, cdfid, varid7, '_FillValue', -999.0
    ncdf_attput, cdfid, varid7, 'missing_value', -999.0
    ncdf_attput, cdfid, varid7, 'coordinates' , 'Longitude Latitude'
    
   ; ;;;;;REFL. nir
    varid8= ncdf_vardef(cdfid, dname[8], [xdimid, ydimid], /float)
    ncdf_attput, cdfid, varid8, 'long_name' , lname[8]
    ncdf_attput, cdfid, varid8, 'units' , units[8]
    ncdf_attput, cdfid, varid8, '_FillValue', -999.0
    ncdf_attput, cdfid, varid8, 'missing_value', -999.0
    ncdf_attput, cdfid, varid8, 'coordinates' , 'Longitude Latitude'
   ; 
   ; ;;;;;REFL. indigo
   ; varid9= ncdf_vardef(cdfid, dname[9], [xdimid, ydimid], /float)
   ; ncdf_attput, cdfid, varid9, 'long_name' , lname[9]
   ; ncdf_attput, cdfid, varid9, 'units' , units[9]
   ; ncdf_attput, cdfid, varid9, '_FillValue', -999.0
   ; ncdf_attput, cdfid, varid9, 'missing_value', -999.0
   ; ncdf_attput, cdfid, varid9, 'coordinates' , 'Longitude Latitude'
   ; 
   ; ;;;;;REFL. violet
   ; varid10= ncdf_vardef(cdfid, dname[10], [xdimid, ydimid], /float)
   ; ncdf_attput, cdfid, varid10, 'long_name' , lname[10]
   ; ncdf_attput, cdfid, varid10, 'units' , units[10]
   ; ncdf_attput, cdfid, varid10, '_FillValue', -999.0
   ; ncdf_attput, cdfid, varid10, 'missing_value', -999.0
   ; ncdf_attput, cdfid, varid10, 'coordinates' , 'Longitude Latitude'
   ; 
  ; ; 'landmask', 'vegi_fraction', 'coszen', 'Leaf_area_index', 'Surface_Skin_Temp', 'albedo', 'Surface_emissivity
  ;  ;landmask
  ;  varid11= ncdf_vardef(cdfid, dname[11], [xdimid, ydimid], /float)
  ;  ncdf_attput, cdfid, varid11, 'long_name' , lname[11]
  ;  ncdf_attput, cdfid, varid11, 'units' , units[11]
  ;  ncdf_attput, cdfid, varid11, '_FillValue', -999.0
  ;  ncdf_attput, cdfid, varid11, 'missing_value', -999.0
  ;  ncdf_attput, cdfid, varid11, 'coordinates' , 'Longitude Latitude'

   ; ;    vegi_fraction
   ; varid12= ncdf_vardef(cdfid, dname[12], [xdimid, ydimid], /float)
   ; ncdf_attput, cdfid, varid12, 'long_name' , lname[12]
   ; ncdf_attput, cdfid, varid12, 'units' , units[12]
   ; ncdf_attput, cdfid, varid12, '_FillValue', -999.0
   ; ncdf_attput, cdfid, varid12, 'missing_value', -999.0
   ; ncdf_attput, cdfid, varid12, 'coordinates' , 'Longitude Latitude'

  ; ;;    coszen
  ;  varid13= ncdf_vardef(cdfid, dname[13], [xdimid, ydimid], /float)
  ;  ncdf_attput, cdfid, varid13, 'long_name' , lname[13]
  ;  ncdf_attput, cdfid, varid13, 'units' , units[13]
  ;  ncdf_attput, cdfid, varid13, '_FillValue', -999.0
  ;  ncdf_attput, cdfid, varid13, 'missing_value', -999.0
  ;  ncdf_attput, cdfid, varid13, 'coordinates' , 'Longitude Latitude'

   ; ;    Leaf_area_index
   ; varid14= ncdf_vardef(cdfid, dname[14], [xdimid, ydimid], /float)
   ; ncdf_attput, cdfid, varid14, 'long_name' , lname[14]
   ; ncdf_attput, cdfid, varid14, 'units' , units[14]
   ; ncdf_attput, cdfid, varid14, '_FillValue', -999.0
   ; ncdf_attput, cdfid, varid14, 'missing_value', -999.0
   ; ncdf_attput, cdfid, varid14, 'coordinates' , 'Longitude Latitude'

    ;;  Surface_Skin_Temp
    ;varid15= ncdf_vardef(cdfid, dname[15], [xdimid, ydimid], /float)
    ;ncdf_attput, cdfid, varid15, 'long_name' , lname[15]
    ;ncdf_attput, cdfid, varid15, 'units' , units[15]
    ;ncdf_attput, cdfid, varid15, '_FillValue', -999.0
    ;ncdf_attput, cdfid, varid15, 'missing_value', -999.0
    ;ncdf_attput, cdfid, varid15, 'coordinates' , 'Longitude Latitude'

   ; ; albedo
   ; varid16= ncdf_vardef(cdfid, dname[16], [xdimid, ydimid], /float)
   ; ncdf_attput, cdfid, varid16, 'long_name' , lname[16]
   ; ncdf_attput, cdfid, varid16, 'units' , units[16]
   ; ncdf_attput, cdfid, varid16, '_FillValue', -999.0
   ; ncdf_attput, cdfid, varid16, 'missing_value', -999.0
   ; ncdf_attput, cdfid, varid16, 'coordinates' , 'Longitude Latitude'

    ;; Surface_emissivity
    ;varid17= ncdf_vardef(cdfid, dname[17], [xdimid, ydimid], /float)
    ;ncdf_attput, cdfid, varid17, 'long_name' , lname[17]
    ;ncdf_attput, cdfid, varid17, 'units' , units[17]
    ;ncdf_attput, cdfid, varid17, '_FillValue', -999.0
    ;ncdf_attput, cdfid, varid17, 'missing_value', -999.0
    ;ncdf_attput, cdfid, varid17, 'coordinates' , 'Longitude Latitude'

    
    
    f_time=STRING(adate +' '+ STRMID(anhr, 0,4))
    p_time=SYSTIME(0, /UTC)
    
    ;;;global variables eastconus

    ncdf_attput, cdfid,  'TITLE', 'SIMULATED GOES-R ABI TOA RADIANCES FOR 8km WRF-CHEM' ,/global
    ncdf_attput, cdfid,  'INSTITUTE', 'NOAA/NESDIS/CIMSS', /global
    ncdf_attput, cdfid,  'HISTORY',   'S4 CONUS DOMAIN SIMULATIONS FOR TESTING RGB IMAGES', /global
    ncdf_attput, cdfid,  'Satellite_name', 'GOES-R'  ,/global
    ncdf_attput, cdfid,  'Instrument', 'ABI'  ,/global
    ncdf_attput, cdfid,  'Scan_Type', ' CONUS'  ,/global
    ncdf_attput, cdfid,  'Earth_sun_distance', 1. ,/global
    ncdf_attput, cdfid,  'FILE_AUTHOR', 'Kaba Bah', /global
    ncdf_attput, cdfid,  'PROCESSED_DATE', p_time, /global
    ncdf_attput, cdfid,  'FM_CVS_VERSION','Release_Sep09_A', /global
    ncdf_attput, cdfid,  'NWP_MODEL', 'OUTPUT FROM WRF-CHEM MODEL', /global
    ncdf_attput, cdfid,  'CEN_LAT', 0.0000  ,/global  
    ncdf_attput, cdfid,  'CEN_LON',-75.000  ,/global 
    ncdf_attput, cdfid,  'Resolution_(km)',8.0  ,/global
    ncdf_attput, cdfid,  'Longitude_Subpoint',-75.000  ,/global
    ncdf_attput, cdfid,  'rotation', 0.     ,/global
    ncdf_attput, cdfid,  'Simulated_time', f_time+'UTC' ,/global
    
    ncdf_control, cdfid, /endef

   
   
   
   
   
   
   
   ;;;;;;;;;;;;;;; PROCESSING TO MAKE R,G,B GUNS     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;;;;;;;;;;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      cutoff=0  ;0.0223
    ;
    ;;land_class
    ; SHALLOW_OCEAN = 0  ; LAND = 1 ; COASTLINE = 2  SHALLOW_INLAND_WATER = 3  EPHEMERAL_WATER = 4 DEEP_INLAND_WATER = 5 MODERATE_OCEAN = 6  DEEP_OCEAN = 7

    ;cloud mask
   ; CLOUDY = 3 PROB_CLOUDY = 2 PROB_CLEAR = 1   CLEAR = 0

   ; 
      ; MULT_COS_ZEBITH, rbn=rbn, lutgreen=lutgreen                  ;;; Correct for effect of solar zenith angle  ; multiply by cos(zenith angle) to get reflectance factor
       ;SET_CUTOFF_VAL, rbn=rbn, lutgreen=lutgreen, cutoff=cutoff    ;;; tks, following paper of miller et al. 2012 set min to 0.0223  ;set cutoof to 0.0223 to follow miller et al. ; here using scaling from ATBD.
       ;APPLY_SQRT_ENHANCEMENT, rbn=rbn, lutgreen=lutgreen           ;;; Apply SQRT enhancement
       CONVERT_TO_EIGHT_BIT, rbn=rbn,  lutgreen=lutgreen, minrefl=minrefl, maxrefl=maxrefl    ;; Convert to 8bits
     ; MODIS_STRETCH, rbn=rbn, lutgreen=lutgreen, minrefl=minrefl, maxrefl=maxrefl           ;; stretch image using MODIS approach
     ;  MASK_STRETCH,  rbn=rbn, lutgreen=lutgreen, cmask=cmask 
     ;  APPLY_NDVI,   rbn=rbn, lutgreen=lutgreen, cmask=cmask
    ;	   
    ;	   
    ;       ;lutgreen(tt)= lutgreen(tt)*ratios[1]
    
    
   ; ;;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
   ; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ; ;;Make secondary colors,, Yellow, Orange, Indigo, Violet
   ; yellow=INTARR(XSIZE,YSIZE)  & orange=INTARR(XSIZE,YSIZE) & cyan=INTARR(XSIZE,YSIZE) & magenta=INTARR(XSIZE,YSIZE) 
   ; yellow=ROUND((1.0*rbn.red.data(*) + 1.0*lutgreen(*))/2.0)               &   cyan=ROUND((1.0*rbn.blue.data(*) + 1.0*lutgreen(*))/2.0)    ;  yellow=ROUND((0.93*red + 0.93*lutgreen)/2.0)
   ; magenta=ROUND((1.0*rbn.red.data(*) + 1.0*lutgreen(*))/2.0)              &   orange=ROUND((1.0*rbn.red.data(*) + 0.40*lutgreen(*))/2.0)
   ; ;indigo=ROUND((0.29*rbn.red.data + 0.51*rbn.blue.data)/2.0)        &   violet=ROUND((0.54*rbn.red.data + 0.37*lutgreen + 0.60*rbn.blue.data)/3.0)
    
    
    
    
    
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;;;;;;;;;;;; WRITE OUT THE FILE       ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
    ncdf_varput, cdfid, varid0, rbn.lat       ;;lats
    ncdf_varput, cdfid, varid1, rbn.lon       ;;lons
    ncdf_varput, cdfid, varid2, rbn.blue      ;;blue
    ncdf_varput, cdfid, varid3, rbn.green     ;;green
    ncdf_varput, cdfid, varid4, rbn.red       ;;red
    ncdf_varput, cdfid, varid5, lutgreen      ;;lutgree 
    ncdf_varput, cdfid, varid6, rbn.landmask  ;;landmask
    ncdf_varput, cdfid, varid7, cmask         ;;cmask
    ncdf_varput, cdfid, varid8, rbn.nir         ;;nir
     
    ;ncdf_varput, cdfid, varid8, orange         ;;orange 
    ;ncdf_varput, cdfid, varid9, cyan           ;;indigo 
    ;ncdf_varput, cdfid, varid10, magenta       ;;violet 
   ; ncdf_varput, cdfid, varid11, cmask.landmask.data            ;;landmask
    ;ncdf_varput, cdfid, varid12, cmask.vegfrac.data             ;;vegi_fraction
    ;ncdf_varput, cdfid, varid13, cmask.coszen.data              ;;coszen
    ;ncdf_varput, cdfid, varid14, cmask.lai.data                 ;;Leaf_area_index
    ;ncdf_varput, cdfid, varid15, cmask.tsk.data                 ;;Surface_Skin_Temp
    ;ncdf_varput, cdfid, varid16, cmask.albedo.data              ;;albedo
    ;ncdf_varput, cdfid, varid17, cmask.emiss.data               ;;Surface_emissivity

    ncdf_close, cdfid
    
    PRINT, 'Wrote the following output file:',ncoutfile
END







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;SUB PROGRAMS   ;;;;;;;;;;;;;;;;;;

 PRO APPLY_NDVI, rbn=rbn, lutgreen=lutgreen, cmask=cmask
  
         print, 'stop'
        diffs=rbn.nir-rbn.red   ;; b03 - b02
        summs=rbn.nir+rbn.red   ;; b03 + b02
        ndvi=diffs/summs
        ratios1=[0.705, 0.94, 0.272] ; 0.90 [0.705, 1.386, 0.272] Deep forest green (31,61,12)
        ;ratios2=[1.702, 1.478, 0.089] ; 0.90 [0.705, 1.386, 0.272] Desert brown (143,99,6)
        ratios3=[1.20, 1.15, 0.90] ; [1.10, 1.00, 0.90] [1.702, 1.478, 0.089]  ; [0.705, 1.386, 0.272] Desert brown (143,99,6)
        
        ;vv=WHERE(cmask LT 2 AND ndvi GT 0.375)    ;; Thicker end of vegitation
        ;ww=WHERE(cmask LT 2 AND ndvi LT 0.145)    ;; 0.125 Clouds over land
        ;xx=WHERE(cmask LT 2 AND ndvi GT 0.165 AND ndvi LE 0.365)    ;; Non vegitated land no cloud
        
        vv=WHERE(rbn.landmask EQ 1 AND ndvi GT 0.375)    ;; Thicker end of vegitation
        ww=WHERE(rbn.landmask EQ 1 AND ndvi LT 0.145)    ;; 0.125 Clouds over land
        xx=WHERE(rbn.landmask EQ 1 AND ndvi GT 0.165 AND ndvi LE 0.365)    ;; Non vegitated land no cloud
         
       ;print, min(rbn.red), max(rbn.red)
       ;; Stretching the green end of the data
        rbn.red(vv)=rbn.red(vv)*ratios1[0]
        rbn.green(vv)=rbn.green(vv)*ratios1[1]
        rbn.blue(vv)=rbn.blue(vv)*ratios1[2]
        lutgreen(vv)= lutgreen(vv)*ratios1[1]
        
       ; ;; Stretching Clouds over land
       ; rbn.red.data(ww)=rbn.red.data(ww)*ratios2[0]
       ; rbn.green.data(ww)=rbn.green.data(ww)*ratios2[1]
       ; rbn.blue.data(ww)=rbn.blue.data(ww)*ratios2[2]
       ; lutgreen(ww)= lutgreen(ww)*ratios2[1]
        
        ;; Stretching the brown end of land no clouds
        rbn.red(xx)=rbn.red(xx)*ratios3[0]
        rbn.green(xx)=rbn.green(xx)*ratios3[1]
        rbn.blue(xx)=rbn.blue(xx)*ratios3[2]
        lutgreen(xx)= lutgreen(xx)*ratios3[1]
  
  END



   PRO MASK_STRETCH, rbn=rbn, lutgreen=lutgreen, cmask=cmask
     ;cloud mask
     ; CLOUDY = 3 PROB_CLOUDY = 2 PROB_CLEAR = 1   CLEAR = 0
  
     ; ;;land_class
     ; SHALLOW_OCEAN = 0  ; LAND = 1 ; COASTLINE = 2  SHALLOW_INLAND_WATER = 3  EPHEMERAL_WATER = 4 DEEP_INLAND_WATER = 5 MODERATE_OCEAN = 6  DEEP_OCEAN = 7

     ; 
    ;ratios=[1.76, 1.98, 2.84] ; Royal Blue   (65, 105,225)
     ;ratios=[0.081, 0.301, 0.60] ; b=0.80, 1.20 Deep ocean Blue   (3, 16,79)  [0.081, 0.301, 1.00]
     ratios=[0.675, 0.471, 0.72] ;0.69 0.569 Midnight blue (25,25,45)
     ratios2=[1.8, 1.7, 1.7]   ;[3.5, 2.69, 2.36]  ;;Thick clouds
     ratios3=[3.5, 2.69, 2.36]    ;[3.5, 2.69, 2.36]  think clouds
     
     ;tt=WHERE(cmask.landmask.data EQ 2 AND rbn.red.data GT 0)  ; ;tt=WHERE(cmask.landmask.data EQ 2) ;;red useds as a temp. cloud mask, tends to be 37 for clouds
     ;tt=WHERE(cmask.landmask.data EQ 2 AND rbn.red.data GT 0 AND rbn.red.data LE 50)  ;;Ocean withouth clouds
     ;zz=WHERE(cmask.landmask.data EQ 2 AND rbn.red.data GT 50)  ;;Clouds over Ocean
     
     tt=WHERE(cmask EQ 0 AND rbn.landmask NE 1)  ;;clear over water  ;Ocean withouth clouds
     zz=WHERE(cmask EQ 3 AND rbn.landmask NE 1) ; AND rbn.red GE 100)  ;;Thick clouds over water
     zzz=WHERE(cmask EQ 3 AND rbn.landmask NE 1 AND rbn.red LT 130)  ;;Thin clouds over water
     
     rbn.red(tt)=rbn.red(tt)*ratios[0]   &   rbn.green(tt)=rbn.green(tt)*ratios[1]
     rbn.blue(tt)=rbn.blue(tt)*ratios[2]  & lutgreen(tt)= lutgreen(tt)*ratios[1]
     
     rbn.red(zzz)=rbn.red(zzz)*ratios2[0]    &   rbn.green(zzz)=rbn.green(zzz)*ratios2[1]
     rbn.blue(zzz)=rbn.blue(zzz)*ratios2[2]  &   lutgreen(zzz)= lutgreen(zzz)*ratios2[1]
     
    ; rbn.red(zzz)=rbn.red(zzz)*ratios3[0]    &   rbn.green(zzz)=rbn.green(zzz)*ratios3[1]
    ; rbn.blue(zzz)=rbn.blue(zzz)*ratios3[2]  &   lutgreen(zzz)= lutgreen(zzz)*ratios3[1]
    
     ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   END
   
   
   PRO MODIS_STRETCH, rbn=rbn, lutgreen=lutgreen, minrefl=minrefl, maxrefl=maxrefl 
   ;   red=ScaleModis(rbn.red.data, RANGE=[minrefl[0], maxrefl[0]])
   ;   blue=ScaleModis(rbn.blue.data, RANGE=[minrefl[1], maxrefl[1]])
   ;   sgreen=ScaleModis(rbn.green.data, RANGE=[minrefl[2], maxrefl[2]])
   ;   nir=ScaleModis(rbn.nir.data, RANGE=[minrefl[3], maxrefl[3]])
   ;   lutgreen=ScaleModis(lutgreen, RANGE=[minrefl[2], maxrefl[2]])
      PRINT, 'Done applying MODIS stretch'
      
      ;;;Stretch to highlight certain areas of the image.  ; cgImage, ScaleModis(chan_01_ref, RANGE=[0.0, 0.75]) 0.75 ABOUT 192 on 0-255
      ;red=ScaleModis(red0, RANGE=[0, 192])
      ;blue=ScaleModis(blue0, RANGE=[0, 192])
      ;sgreen=ScaleModis(sgreen0, RANGE=[0, 192]) 
        
      
      ;nir=ScaleModis(nir0, RANGE=[0, 192])
      ;lutgreen=ScaleModis(lutgreen0, RANGE=[0, 192])

   END
   
   
   
   PRO CONVERT_TO_EIGHT_BIT, rbn=rbn, lutgreen=lutgreen, minrefl=minrefl, maxrefl=maxrefl
      
       PRINT, 'Begin converting to 8bits'
       ;;;CONVERT TO 0-255   BEFORE WRITTING OUT
       ;;; flag out of range values and set them to within range
       aa=Where(rbn.red LT minrefl[0])    & bb=Where(rbn.red GT maxrefl[0])
       cc=Where(rbn.blue LT minrefl[1])   & dd=Where(rbn.blue GT maxrefl[1])
       ee=Where(rbn.green LT minrefl[2])  & ff=Where(rbn.green GT maxrefl[2])
       gg=Where(rbn.nir LT minrefl[3])    & hh=Where(rbn.nir GT maxrefl[3])

       rbn.red(aa)=minrefl[0]    &   rbn.red(bb)=maxrefl[0]
       rbn.blue(cc)=minrefl[1]   &   rbn.blue(dd)=maxrefl[1]
       rbn.green(ee)=minrefl[2]  &   rbn.green(ff)=maxrefl[2]
       rbn.nir(gg)=minrefl[3]    &   rbn.nir(hh)=maxrefl[3]
       
       ;;Convert to 0-255
       rbn.red=BYTSCL(rbn.red, min=minrefl[0], max=maxrefl[0])      &   rbn.blue=BYTSCL(rbn.blue, min=minrefl[1], max=maxrefl[1])
       rbn.green=BYTSCL(rbn.green, min=minrefl[2], max=maxrefl[2])  &    lutgreen=BYTSCL(lutgreen, min=minrefl[2], max=maxrefl[2])  ;&   rbn.nir=BYTSCL(rbn.nir, min=minrefl[3], max=maxrefl[3])  

       
       PRINT, 'Done converting to 8bits'

   END


   PRO APPLY_SQRT_ENHANCEMENT, rbn=rbn, lutgreen=lutgreen
     print, 'Begin applying sqrt enhancement'
     print, 'Before applying SQRT Enhancement'
     print, min(rbn.red), max(rbn.red)
     print, min(rbn.blue), max(rbn.blue)
     print, min(rbn.green), max(rbn.green)
     print, min(rbn.nir), max(rbn.nir)
     print, min(lutgreen), max(lutgreen)
     
     ;rbn.red=(ROUND(SQRT(rbn.red*100.)*25.5))/255.
     ;rbn.blue=(ROUND(SQRT(rbn.blue*100.)*25.5))/255.
     ;rbn.green=(ROUND(SQRT(rbn.green*100.)*25.5))/255.
    ;; rbn.nir=(ROUND(SQRT(rbn.nir*100.)*25.5))/255.
     ;lutgreen=(ROUND(SQRT(lutgreen*100.)*25.5))/255.
     
     rbn.red=(ROUND(SQRT(rbn.red)*25.5))/255.
     rbn.blue=(ROUND(SQRT(rbn.blue)*25.5))/255.
     rbn.green=(ROUND(SQRT(rbn.green)*25.5))/255.
      rbn.nir=(ROUND(SQRT(rbn.nir)*25.5))/255.
     lutgreen=(ROUND(SQRT(lutgreen)*25.5))/255.

     print, 'After applying SQRT Enhancement'
     print, min(rbn.red), max(rbn.red)
     print, min(rbn.blue), max(rbn.blue)
     print, min(rbn.green), max(rbn.green)
     print, min(rbn.nir), max(rbn.nir)
     print, min(lutgreen), max(lutgreen) 
     print, 'Done applying SQRT enhancement'
   END

   PRO SET_CUTOFF_VAL, rbn=rbn, lutgreen=lutgreen, cutoff=cutoff
   
     Print, 'Setting lower cut off value to:','1' ;cutoff 
     index=where(rbn.red lt cutoff)
     if index(0) ne -1 then rbn.red(index)=1   ;cutoff
     index=where(rbn.blue lt cutoff)
     if index(0) ne -1 then rbn.blue(index)=1  ;cutoff
     index=where(rbn.green lt cutoff)
     if index(0) ne -1 then rbn.green(index)=1  ;cutoff
     ;index=where(rbn.nir lt cutoff)
     ;if index(0) ne -1 then rbn.nir(index)=1    ;cutoff
     index=where(lutgreen lt cutoff)
     if index(0) ne -1 then lutgreen(index)=1  ;cutoff
     Print, 'Cutoff value has been set to', '1' ; cutoff
      
   END
   
   
   
    PRO MULT_COS_ZEBITH, rbn=rbn, lutgreen=lutgreen  
      aconst=!pi/180.
      print, 'Begin correcting for solarzen'
      ;print, 'Before correcting for solarzen'
      print, min(rbn.red), max(rbn.red)
      print, min(rbn.blue), max(rbn.blue)
      print, min(rbn.green), max(rbn.green)
      ;print, min(rbn.nir), max(rbn.nir)
      print, min(lutgreen), max(lutgreen)

      rbn.red=(rbn.red*cos(rbn.solarzen*aconst))
      rbn.blue=(rbn.blue*cos(rbn.solarzen*aconst))
      rbn.green=(rbn.green*cos(rbn.solarze*aconst))
     ; rbn.nira=(rbn.nir*cos(rbn.solarzen*aconst))
      lutgreen=(lutgreen*cos(rbn.solarzen*aconst))

      print, 'After correcting for solarzen'
      print, min(rbn.red), max(rbn.red)
      print, min(rbn.blue), max(rbn.blue)
      print, min(rbn.green), max(rbn.green)
      ;print, min(rbn.nir), max(rbn.nir)
      print, min(lutgreen), max(lutgreen) 
      print, 'Done correcrting for solarzen'
    END
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
